%{
open Language
%}
  
%token <string> PROP_VAR
%token FALSE NOT AND OR IMP IFF
%token LPAREN RPAREN
%token EOL

%right IMP IFF       /* lowest precedence */
%left AND OR         /* medium precedence */
%nonassoc NOT        /* highest precedence */

%start <Language.wff option> main

%%

main:
| f = form EOL
    { Some f }
| EOL
    { None }
    
form:
| FALSE
     { False }	
| s = PROP_VAR
    { P(s) }
| LPAREN f = form RPAREN
    { f }
| NOT f = form 
    { Neg (f) }
| f1 = form AND f2 = form
    { And(f1, f2) }
| f1 = form OR f2 = form
    { Or(f1,f2) }
| f1 = form IMP f2 = form
    { Imp(f1,f2) }
| f1 = form IFF f2 = form
    { Iff(f1,f2) }
